package cn.com.infosec.asn1;

import java.io.EOFException;
import java.io.InputStream;

class IndefiniteLengthInputStream extends LimitedInputStream {
   private int _b1;
   private int _b2;
   private boolean _eofReached = false;
   private boolean _eofOn00 = true;

   IndefiniteLengthInputStream(InputStream in) {
      super(in);
      this._b1 = in.read();
      boolean in1;
      if ((this._b2 = in.read()) < 0) {
         in1 = true;
      } else {
         in1 = false;
      }

      this._eofReached = in1;
   }

   void setEofOn00(boolean eofOn00) {
      this._eofOn00 = eofOn00;
   }

   boolean checkForEof() {
      if (this._eofOn00 && this._b1 == 0 && this._b2 == 0) {
         this._eofReached = true;
         this.setParentEofDetect(true);
      }

      return this._eofReached;
   }

   public int read(byte[] b, int off, int len) {
      if (!this._eofOn00 && len >= 3) {
         if (this._eofReached) {
            return -1;
         } else {
            int var10002 = len;
            len = off + 2;
            if ((len = super._in.read(b, len, var10002 - 2)) >= 0) {
               b[off] = (byte)this._b1;
               b[off + 1] = (byte)this._b2;
               this._b1 = super._in.read();
               if ((this._b2 = super._in.read()) >= 0) {
                  return len + 2;
               } else {
                  throw new EOFException();
               }
            } else {
               throw new EOFException();
            }
         }
      } else {
         return super.read(b, off, len);
      }
   }

   public int read() {
      if (this.checkForEof()) {
         return -1;
      } else {
         int var1;
         if ((var1 = super._in.read()) >= 0) {
            int var10000 = this._b1;
            this._b1 = this._b2;
            this._b2 = var1;
            return var10000;
         } else {
            throw new EOFException();
         }
      }
   }
}
